#include <avr/io.h>
#include <util/delay.h>
#include <string.h>
#include <stdio.h>
#include "spi.h"
#include "glcd.h"

#define F_CPU 16000000UL  // 4 MHz

#define byte unsigned char




byte n=0;
byte s1,s2;
byte r,g,b;
uint8_t color=0;
uint8_t xCoord=0;
uint8_t yCoord=0;
uint8_t memAccessCtrl=0;
uint8_t fontOffset=0;
uint8_t bin[8]={1,1,0,0,1,1,0,1};

font f;

//Funktionen
void lcdinit(void);
void sendCMD(byte cmd);
void sendData(byte cmd);
void shiftBits(byte b);
void lcd_box(int lx1,int lx2,int ly1,int ly2,unsigned char color);
void clsdsp(unsigned char color);
void Lcd_window(int lx1,int lx2,int ly1,int ly2);
//DISPLAY TIMING
void waitms(int ms)
 {
  int i;
  for (i=0;i<ms;i++) _delay_ms(1);
}

SIGNAL(SIG_SPI) {

    SPCR &= ~(1 << SPE);
    PORTB |= (1 << 5);
}


/* Wartet auf Beendigung des Transfers */
inline void glcdDisplayWait(void) {

    while (SPCR & (1 << SPE)) {
      while (!(SPSR & (1 << SPIF)));
      SPCR &= ~(1 << SPE);
    }
}

//INIT DISPLAY
void lcdinit (void) 
 {
int i;
displ_Enable();

  SDA0
  CLK1
  RESET1
  RESET0
  waitms(10);
  RESET1

  CLK1
  SDA1
  CLK1

  sendCMD(0x01);
  waitms(10);
  sendCMD(0x11);
  waitms(40);
  sendCMD(0x29);
  waitms(40);
  sendCMD(0x3a);
  sendData(0x02);
  sendCMD(0x20);
  sendCMD(0x36);
  sendData(0x00);
  sendCMD(0x2d);

//FARBTABELLE 254
unsigned char lcdinitd[]={0x00 , 0x02 , 0x04 , 0x06 , 0x09 , 0x0B , 0x0D , 0x0F , 0x00 , 0x02 , 0x04 , 0x06 , 0x09 , 0x0B , 0x0D , 0x0F , 0x00 , 0x04 , 0x0B , 0x0F};

for (i=0;i<20;i++)
{
sendData(lcdinitd[i]);
}
clsdsp(blau);  
}

void clsdsp(unsigned char color)
{  
lcd_box(0,131,0,131,color);
}



//Display Fenster definieren
void lcd_box(int lx1,int lx2,int ly1,int ly2,unsigned char color)
{
Lcd_window(lx1,lx2,ly1,ly2);
int px;
int py;
int pixel;
int i;
   px = lx2 - lx1;
   px++; 
   py = ly2 - ly1;
   py++;
   pixel = px * py;
   for (i= 0;i<=pixel;i++)
   {
   sendData(color);

   }



}


//Fenster AdressBereich setzen
void Lcd_window(int lx1,int lx2,int ly1,int ly2)
{  sendCMD(0x2A);
   sendData(lx1);
   sendData(lx2);
   sendCMD(0x2B);
   sendData(ly1);
   sendData(ly2);
   sendCMD(0x2C);
  
}






void shiftBits(byte b) {

  CLK0
  if ((b&128)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&64)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&32)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&16)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&8)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&4)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&2)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&1)!=0) SDA1 else SDA0
  CLK1

}


//send data
void sendData(byte data) {
  glcdDisplayWait();
  
  CLK0
  SDA1                                                 //1 for param
  CLK1

  shiftBits(data);
}

//send cmd
void sendCMD(byte data) {

    glcdDisplayWait();
  
  CLK0
  SDA0                                                 //1 for cmd
  CLK1

  shiftBits(data);
}
//__attribute__ ((section(".eeprom")))
