#include <avr/pgmspace.h>
#define SPIPORT PORTB
#define SPIDDR DDRB
#define CS 5
#define CLK 1
#define SDA 2
#define RESET 6
#define cbi(reg, bit) (reg&=~(1<<bit))
#define sbi(reg, bit) (reg|= (1<<bit))
#define CS0 cbi(SPIPORT,CS);
#define CS1 sbi(SPIPORT,CS);
#define CLK0 cbi(SPIPORT,CLK);
#define CLK1 sbi(SPIPORT,CLK);
#define SDA0 cbi(SPIPORT,SDA);
#define SDA1 sbi(SPIPORT,SDA);
#define RESET0 cbi(SPIPORT,RESET);
#define RESET1 sbi(SPIPORT,RESET);
#define disp_Write			PORTB	//Port an der die MMC/SD-Karte angeschlossen ist also des SPI 
#define displ_Enable() disp_Write&=~(1<<CS);
#define displ_Disable() disp_Write|= (1<<CS);

#define weiss	0xff
#define blau	0x03
#define schwarz	0x00
#define rot 	0xe0
#define gelb	0xfc
#define gruen	0x1c
#define SOFT_RESET		0x01
#define SLEEP_OUT		0x11
#define DISPLAY_ON		0x29
#define BOOSTER_ON		0x03
#define COLOR_INTERFACE	0x3A
  #define COLOR_8_BIT	0x02
#define COLOR_SET		0x2D
#define MEM_ACCESS_CTRL	0x36
  #define MIRROR_X		6
  #define MIRROR_Y		7
  #define VERT_WRITE	5
  #define RGB			3
#define MEM_WRITE		0x2C
#define SET_X_ADDR		0x2A
#define SET_Y_ADDR		0x2B

/*
 * for n6100SetDrawRect();
 */
#define DISP_X_START	0
#define DISP_Y_START	0
#define DISP_X_END	129
#define DISP_Y_END	129

/*
 * a few basic colors
 */
#define RED				0xE0
#define GREEN			0x1C
#define BLUE			0x03
#define YELLOW			0xFC
#define MAGENTA			0xE3
#define CYAN			0x1F
#define BLACK			0x00
#define WHITE			0xFF
 



typedef unsigned char uint8_t;
/*
 * Function Prototypes
 */
void lcdinit(void);
void clsdsp(unsigned char color);
